<template>
  <AppPage>
    <h1>Course Refresh</h1>
    <p>Refresh a course's title from MaineStreet</p>
    <CourseSelectorMaineStreet @change="selector_course"/>
    <div v-show="selected_course_code.length > 0">
      <b-card bg-variant="danger" v-if="!hasPermission('put:lmsCourse-byCode')">
        You do not have the permission to refresh a course
      </b-card>
      <div v-if="hasPermission('put:lmsCourse-byCode')">
        <b-card-group deck class="mt-2">
          <b-overlay :show="ms_title_fetching">
            <b-card title="MaineStreet" class="m-1">
              <b-card-text>{{ ms_title_display }}</b-card-text>
              <div id="btnRefreshCourse">
                <b-button
                    :disabled="!updatable"
                    @click.stop.prevent="updateTitle"
                >Update Brightspace with this Title
                </b-button>
              </div>
              <AdminHelpTooltip
                  target="btnRefreshCourse"
                  permissions="put:lmsCourse-byCode"
              />
            </b-card>
          </b-overlay>
          <b-overlay :show="bs_title_fetching">
            <b-card title="Brightspace" class="m-1">
              <b-card-text>{{ bs_title_display }}</b-card-text>
            </b-card>
          </b-overlay>
        </b-card-group>
      </div>
    </div>
  </AppPage>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  computed: {
    ...mapGetters({
      ms_title: 'Courses/Refresh/ms_title',
      ms_title_fetching: 'Courses/Refresh/ms_title_fetching',
      bs_title: 'Courses/Refresh/bs_title',
      bs_title_fetching: 'Courses/Refresh/bs_title_fetching',
      selected_course_code: 'selected_course_code',
      hasPermission: 'Navbar/hasPermission'
    }),
    ms_title_display () {
      if (this.ms_title === null) {
        return 'Course is not currently managed by the integration';
      }

      return this.ms_title;
    },
    bs_title_display () {
      if (this.bs_title === null) {
        return 'Course is not currently managed by the integration';
      }

      return this.bs_title;
    },
    updatable () {
      if (this.ms_title === null || this.bs_title === null) {
        return false;
      }

      if (this.ms_title_fetching || this.bs_title_fetching) {
        return false;
      }

      if (this.ms_title === '' || this.bs_title === '') {
        return false;
      }

      return this.ms_title !== this.bs_title;
    }
  },
  methods: {
    ...mapActions({
      get_ms_title: 'Courses/Refresh/get_ms_title',
      get_bs_title: 'Courses/Refresh/get_bs_title',
      update_bs_title: 'Courses/Refresh/update_bs_title'
    }),
    updateTitle () {
      if (this.hasPermission('put:lmsCourse-byCode')) {
        this.update_bs_title(this.selected_course_code);
      }
    },
    selector_course (code) {
      if (code.length > 0) {
        if (this.hasPermission('get:lmsCourse-byCode')) {
          this.get_bs_title(code);
        }
        if (this.hasPermission('get:course-byCode')) {
          this.get_ms_title(code);
        }
      }
    }
  },
  mounted () {
    this.selector_course(this.selected_course_code);
  }
};
</script>
